/* Copyright 1988 Stephan v. Bechtolsheim */

/* This file is part of the TeXPS Software Package.

The TeXPS Software Package is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY.  No author or distributor
accepts responsibility to anyone for the consequences of using it
or for whether it serves any particular purpose or works at all,
unless he says so in writing.  Refer to the TeXPS Software Package
General Public License for full details.

Everyone is granted permission to copy, modify and redistribute
the TeXPS Software Package, but only under the conditions described in the
TeXPS Software Package General Public License.   A copy of this license is
supposed to have been given to you along with TeXPS Software Package so you
can know your rights and responsibilities.  It should be in a
file named CopyrightLong.  Among other things, the copyright notice
and this notice must be preserved on all copies.  */

/* Identification for pdr files. */
#define PDR_FILE_ID 1564

/* List of the different character types of PS fonts. */
#define CT_NONE -1 /* No type set up yet. */
#define CT_AFM 0 /* Character code from afm file. */
#define CT_ASS 1 /* Character code assigned by pfd2tfm program. */
#define CT_EXECPS 2 /* PS procedure character (executes PS code). */
/* The following is needed for font emulation, where you can have the
 * case where the font to be emulated has a character at a certain
 * position but the font being used for emulation does not. In this
 * case the driver will move horizontally (to the right) by the amount
 * of the original width without printing anything. */
#define CT_WIDTH_ONLY 3 /* A character for which only the width is given. */
#define CT_SLITEX_CHAR 4 /* A slitex character font. */
#define MAX_CHAR_PS 256
